backend/controllers/CallTypeController.php
<?php

namespace backend\controllers;

use Yii;
use yii\filters\AccessControl;
use backend\models\CallType;
use backend\models\CallTypeSearch;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * CallTypeController implements the CRUD actions for CallType model.
 */
class CallTypeController extends Controller
{
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'rules' => [
                    [
                        //'actions' => ['index', 'view'],
                        'allow' => true,
						'roles' => ['request_type_edit']
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['post'],
                ],
            ],
        ];
    }

    /**
     * Lists all CallType models.
     * @return mixed
     */
    public function actionIndex()
    {
        $searchModel = new CallTypeSearch();
        $dataProvider = $searchModel->search(Yii::$app->request->queryParams);

        return $this->render('index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single CallType model.
     * @param integer $id
     * @return mixed
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new CallType model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new CallType();

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            //return $this->redirect(['view', 'id' => $model->id]);
			return $this->redirect(['index']);
        } else {
            return $this->render('create', [
                'model' => $model,
            ]);
        }
    }

    /**
     * Updates an existing CallType model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
			$this->saveStyle();
			return $this->redirect(['index']);
        } else {
            return $this->render('update', [
                'model' => $model,
            ]);
        }
    }

    /**
     * Deletes an existing CallType model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    public function saveStyle()
    {
		$str = '';
		foreach(\backend\models\CallType::getColors() as $key => $color){
			$str .= "tr.color_rec_{$key} > td:nth-last-child(1n+2){\n". ((!empty($color)) ? "\tbackground-color:{$color};" : '') ."\n}\n";
		}
		file_put_contents(\Yii::$app->basePath.'/web/css/colors.css', $str);
    }

    /**
     * Finds the CallType model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return CallType the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = CallType::findOne($id)) !== null) {
            return $model;
        } else {
            throw new NotFoundHttpException('The requested page does not exist.');
        }
    }
}

backend/views/call-type/_form.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/* @var $this yii\web\View */
/* @var $model backend\models\CallType */
/* @var $form yii\widgets\ActiveForm */
?>

<div class="call-type-form col-md-7 col-sm-10">

    <?php $form = ActiveForm::begin(); ?>

    <?= $form->field($model, 'name')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'color')->textInput(['maxlength' => true, 'class'=>'form-control j_color_select']) ?>

    <div class="form-group">
        <?= Html::submitButton($model->isNewRecord ? Yii::t('app', 'Create') : Yii::t('app', 'Update'), ['class' => $model->isNewRecord ? 'btn btn-success' : 'btn btn-primary']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div>

backend/views/call-type/_search.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/* @var $this yii\web\View */
/* @var $model backend\models\CallTypeSearch */
/* @var $form yii\widgets\ActiveForm */
?>

<div class="call-type-search">

    <?php $form = ActiveForm::begin([
        'action' => ['index'],
        'method' => 'get',
    ]); ?>

    <?= $form->field($model, 'id') ?>

    <?= $form->field($model, 'name') ?>

    <?= $form->field($model, 'color') ?>

    <div class="form-group">
        <?= Html::submitButton(Yii::t('app', 'Search'), ['class' => 'btn btn-primary']) ?>
        <?= Html::resetButton(Yii::t('app', 'Reset'), ['class' => 'btn btn-default']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div>

backend/views/call-type/create.php
<?php

use yii\helpers\Html;


/* @var $this yii\web\View */
/* @var $model backend\models\CallType */

$this->title = Yii::t('app', 'Create Call Type');
$this->params['breadcrumbs'][] = ['label' => Yii::t('app', 'Call Types'), 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="call-type-create">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

backend/views/call-type/index.php
<?php

use yii\helpers\Html;
use yii\grid\GridView;

/* @var $this yii\web\View */
/* @var $searchModel backend\models\CallTypeSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = Yii::t('app', 'Call Types');
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="call-type-index">
    <h1><?= Html::encode($this->title) ?></h1>
    <p>
        <?= Html::a(Yii::t('app', 'Create Call Type'), ['create'], ['class' => 'btn btn-success']) ?>
    </p>
    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'filterModel' => $searchModel,
		'rowOptions' => function($model, $key, $index, $grid){
			return ['class' => 'color_rec_'.$model->id];
		},
        'columns' => [
			[
				'attribute'=>'id',
				'contentOptions' => array('width' => '5%', 'align'=>'center'),
            ],
			[
				'attribute'=>'name',
			],

		
			[
				'class' => 'yii\grid\ActionColumn',
				'template' => '<p style="white-space: nowrap;">{update} {delete}</p>',
				'buttons' => [
					'update' => function($url, $model) {
						if (!$model->canEdit())
							return;
						$url = \yii\helpers\Url::toRoute(['/call-type/update', 'id' => $model->id]);
						return Html::a('<span class="glyphicon glyphicon-pencil"></span>', $url, [
							'title' => 'Редактирование',
							'data-pjax' => '0',
						]);
					},
					'delete' => function($url, $model) {
						if (!$model->canDelete())
							return;
						$url = \yii\helpers\Url::toRoute(['/call-type/delete', 'id' => $model->id]);
						return Html::a('<span class="glyphicon glyphicon-trash"></span>', $url, [
							'aria-label'=>"Удалить",
							'data-confirm'=>"Вы уверены, что хотите удалить этот элемент?",
							'data-method'=>"post",
							'data-pjax'=>"0",						
							'title' => 'Удалить',
							'data-pjax' => '0',	
						]);
					},
				],
				'contentOptions' => array('class' => 'col-xs-1', 'align'=>'center'),
			]			
        ],
    ]); ?>
</div>

backend/views/call-type/update.php
<?php

use yii\helpers\Html;

/* @var $this yii\web\View */
/* @var $model backend\models\CallType */

$this->title = Yii::t('app', 'Update {modelClass}: ', [
    'modelClass' => 'Call Type',
]) . ' ' . $model->name;
$this->params['breadcrumbs'][] = ['label' => Yii::t('app', 'Call Types'), 'url' => ['index']];
$this->params['breadcrumbs'][] = ['label' => $model->name, 'url' => ['view', 'id' => $model->id]];
$this->params['breadcrumbs'][] = Yii::t('app', 'Update');
?>
<div class="call-type-update">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

backend/views/call-type/view.php
<?php

use yii\helpers\Html;
use yii\widgets\DetailView;

/* @var $this yii\web\View */
/* @var $model backend\models\CallType */

$this->title = $model->name;
$this->params['breadcrumbs'][] = ['label' => Yii::t('app', 'Call Types'), 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="call-type-view">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a(Yii::t('app', 'Update'), ['update', 'id' => $model->id], ['class' => 'btn btn-primary']) ?>
        <?= Html::a(Yii::t('app', 'Delete'), ['delete', 'id' => $model->id], [
            'class' => 'btn btn-danger',
            'data' => [
                'confirm' => Yii::t('app', 'Are you sure you want to delete this item?'),
                'method' => 'post',
            ],
        ]) ?>
    </p>

    <?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            'id',
            'name',
            'color',
        ],
    ]) ?>

</div>